#include <stdbool.h>
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>

typedef struct _link {
	int value;
	struct _link *next;
} elem;

typedef struct _list {
	elem *head;
} list;

list list_create() {
	list ll;
	ll.head = NULL;
	return ll;
}

void list_destroy(list* ll) {
	elem *e = ll->head;
	while (ll->head != NULL) {
		ll->head = ll->head->next;
		free(e);
		e = ll->head;
	}
}

void list_push(list* ll, const int v) {
	elem *e = malloc(sizeof(elem));
	e->value = v;
	e->next = ll->head;
	ll->head = e;
}

void list_print(const list *ll) {
	elem *e = ll->head;
	while (e != NULL) {
		printf("%d", e->value);
		if (e->next != NULL) { printf(" "); }
		e = e->next;
	}
	printf("\n");
}

// ^^^^ repris de la question 2


list pascal(const int line) {
	if (line <= 1) {
		list ll = list_create();
		list_push(&ll, 1);
		return ll;
	} else {
		list prevline = pascal(line-1);  // rec
		// 2l: on "triche" et on utilise la symmétrie du triangle
		list ll = list_create();
		list_push(&ll, 1);
		elem *above = prevline.head;
		elem *northwest = prevline.head->next;
		while (northwest != NULL) {
			// même trick
			list_push(&ll, above->value + northwest->value);
			above = northwest;
			northwest = northwest->next;
		}
		list_push(&ll, 1);
		list_destroy(&prevline);
		return ll;
	}
}


int main() {
	int line;
	scanf("%d", &line);
	printf("\n");
	list ll = pascal(line);
	list_print(&ll);
	list_destroy(&ll);
	return EXIT_SUCCESS;
}
